     function mon = monitor(u,z,choice,t)
%...
%... The MatMol Group (2009)
%...
     global ne n dltz
     global alpha
%...
%... compute dltz(i) = z(i)-z(i-1)
%...
     dltz(2:n+2)=diff(z);
     dltz(1)=dltz(2);
     dltz(n+3)=dltz(n+2);
     
     switch choice
         
         case('der1-1')
%...
%...     compute dltu(i,j)=u(i,j)-u(i-1,j)           
%...
             dltu(2:n+2,:)=diff(u);
%...
%...     compute monitor function :
%...
%...                              1    ne (u(i+1,j)-u(i,j))^2
%...        m(i) = sqrt[ alpha + ---  sum ------------------- ]
%...                              ne  j=1   (z(i+1)-z(i))^2
%...
%...
             quot(1:n+1,:)=dltu(2:n+2,:)./repmat(dltz(2:n+2)',1,ne);
             if ne==1
                 mon=sqrt(alpha+(quot.*quot)'/ne);
             else
                 mon=sqrt(alpha+sum((quot.*quot)')/ne);
             end
           
         case('der1-2')
%...
%...     compute dltu(i,j)=u(i,j)-u(i-1,j)           
%...
             dltu(2:n+2,:)=diff(u);
%...
%...     compute monitor function :
%...
%...                                (u(i+1,j)-u(i,j))^2
%...        m(i) = sqrt[ alpha + max ------------------- ]
%...                              j  (z(i+1)-z(i))^2
%...
             if ne==1
                 mon=sqrt(alpha+((dltu(2:n+2,1)'./dltz(2:n+2)).^2));
             else
                 mon=sqrt(alpha+max((dltu(2:n+2,:).^2)')./(dltz(2:n+2).^2));
             end

         case('der1-3')
%...
%...     compute du/dz by 3_pt_centered scheme           
%...
             D1 = three_point_centered_D1(z);
             uz = D1*u;
             uze = (uz(1:n+1,:)+uz(2:n+2,:))/2;
%...
%...     compute monitor function
%...
%...                              1    ne  uz(i+1,j)+uz(i,j)
%...        m(i) = sqrt[ alpha + ---  sum (-----------------)^2]
%...                              ne  j=1          2  
%...
%...
             if ne==1
                 mon=sqrt(alpha+(uze.*uze)'/ne);
             else
                 mon=sqrt(alpha+sum((uze.*uze)')/ne);
             end

         case('der1-4')
%...
%...     compute du/dz by 3_pt_centered scheme           
%...
             D1 = three_point_centered_D1(z);
             uz = D1*u;
             uze = (uz(1:n+1,:)+uz(2:n+2,:))/2;
%...
%...     compute monitor function
%...
%...                                  uz(i+1,j)+uz(i,j)
%...        m(i) = sqrt[ alpha + max (-----------------)^2]
%...                              j           2  
%...
%...
             if ne==1
                 mon=sqrt(alpha+(uze.*uze)');
             else
                 mon=sqrt(alpha+max((uze.*uze)'));
             end

         case('der1-5')
%...
%...     compute du/dz by 3_pt_upwind scheme           
%...
             v=1;
             D1 = three_point_upwind_D1(z,v);
             uz = D1*u;
             uze = (uz(1:n+1,:)+uz(2:n+2,:))/2;
%...
%...     compute monitor function
%...
%...                              1    ne  uz(i+1,j)+uz(i,j)
%...        m(i) = sqrt[ alpha + ---  sum (-----------------)^2]
%...                              ne  j=1          2  
%...
%...
             if ne==1
                 mon=sqrt(alpha+(uze.*uze)'/ne);
             else
                 mon=sqrt(alpha+sum((uze.*uze)')/ne);
             end

         case('der1-6')
%...
%...     compute du/dz by 3_pt_upwind scheme           
%...
             v=1;
             D1 = three_point_upwind_D1(z,v);
             uz = D1*u;
             uze = (uz(1:n+1,:)+uz(2:n+2,:))/2;
%...
%...     compute monitor function
%...
%...                                  uz(i+1,j)+uz(i,j)
%...        m(i) = sqrt[ alpha + max (-----------------)^2]
%...                              j           2  
%...
%...
             if ne==1
                 mon=sqrt(alpha+(uze.*uze)');
             else
                 mon=sqrt(alpha+max((uze.*uze)'));
             end

         case('der2-1')
%...
%...     compute d2u/dz2 by 3_pt_centered scheme           
%...
             D2 = three_point_centered_D2(z);
             uzz = D2*u;
             uzze = (uzz(1:n+1,:)+uzz(2:n+2,:))/2;
%...
%...     compute monitor function
%...
%...                              1    ne     uzz(i+1,j)+uzz(i,j)
%...        m(i) = sqrt[ alpha + ---  sum abs(-------------------)]
%...                              ne  j=1           2  
%...
%...
             if ne==1
                 mon=sqrt(alpha+(abs(uzze))'/ne);
             else
                 mon=sqrt(alpha+sum((abs(uzze))')/ne);
             end

         case('der2-2')
%...
%...     compute d2u/dz2 by 3_pt_centered scheme           
%...
             D2 = three_point_centered_D2(z);
             uzz = D2*u;
             uzze = (uzz(1:n+1,:)+uzz(2:n+2,:))/2;
%...
%...     compute monitor function
%...
%...                              1           uzz(i+1,j)+uzz(i,j)
%...        m(i) = sqrt[ alpha + ---  max abs(-------------------)]
%...                              ne   j             2  
%...
%...
             if ne==1
                 mon=sqrt(alpha+(abs(uzze))');
             else
                 mon=sqrt(alpha+max(abs(uzze)'));
             end
           
         case('der2-3')
%...
%...     compute d2u/dz2 by 5_pt_centered scheme           
%...
             D2 = five_point_centered_D2(z);
             uzz = D2*u;
             uzze = (uzz(1:n+1,:)+uzz(2:n+2,:))/2;
%...
%...     compute monitor function
%...
%...                              1    ne     uzz(i+1,j)+uzz(i,j)
%...        m(i) = sqrt[ alpha + ---  sum abs(-------------------)]
%...                              ne  j=1           2  
%...
%...
             if ne==1
                 mon=sqrt(alpha+(abs(uzze))'/ne);
             else
                 mon=sqrt(alpha+sum((abs(uzze))')/ne);
             end

         case('der2-4')
%...
%...     compute d2u/dz2 by 5_pt_centered scheme           
%...
             D2 = five_point_centered_D2(z);
             uzz = D2*u;
             uzze = (uzz(1:n+1,:)+uzz(2:n+2,:))/2;
%...
%...     compute monitor function
%...
%...                              1           uzz(i+1,j)+uzz(i,j)
%...        m(i) = sqrt[ alpha + ---  max abs(-------------------)]
%...                              ne   j             2  
%...
%...
             if ne==1
                 mon=sqrt(alpha+(abs(uzze))');
             else
                 mon=sqrt(alpha+max(abs(uzze)'));
             end
           
         case('derfl1-1')
%...
%...     compute dltfl[u(i,j)]=fl[u(i+1,j)]-fl[u(i,j)]           
%...
             dltu(2:n+2,:)=diff(Flux_DynGrid(n,ne,t,u));
%...
%...     compute monitor function :
%...
%...                              1    ne (fl[u(i+1,j)]-fl[u(i,j)])^2
%...        m(i) = sqrt[ alpha + ---  sum --------------------------- ]
%...                              ne  j=1      (z(i+1)-z(i))^2
%...
%...
             quot(1:n+1,:)=dltu(2:n+2,:)./repmat(dltz(2:n+2)',1,ne);
             if ne==1
                 mon=sqrt(alpha+(quot.*quot)'/ne);
             else
                 mon=sqrt(alpha+sum((quot.*quot)')/ne);
             end
           
         case('derfl1-2')
%...
%...     compute dltfl[u(i,j)]=fl[u(i+1,j)]-fl[u(i,j)]           
%...
             dltu(2:n+2,:)=diff(Flux_DynGrid(n,ne,t,u));
%...
%...     compute monitor function :
%...
%...                                (fl[u(i+1,j)]-fl[u(i,j)])^2
%...        m(i) = sqrt[ alpha + max -------------------------- ]
%...                              j      (z(i+1)-z(i))^2
%...
             if ne==1
                 mon=sqrt(alpha+((dltu(2:n+2,1)'./dltz(2:n+2)).^2));
             else
                 mon=sqrt(alpha+max((dltu(2:n+2,:).^2)')./(dltz(2:n+2).^2));
             end

         case('derfl1-3')
%...
%...     compute dfl(u)/dz by 3_pt_centered scheme           
%...
             D1 = three_point_centered_D1(z);
             fluz = D1*Flux_DynGrid(n,ne,t,u);
             fluze = (fluz(1:n+1,:)+fluz(2:n+2,:))/2;
%...
%...     compute monitor function
%...
%...                              1    ne  fluz(i+1,j)+fluz(i,j)
%...        m(i) = sqrt[ alpha + ---  sum (---------------------)^2]
%...                              ne  j=1            2  
%...
%...
             if ne==1
                 mon=sqrt(alpha+(fluze.*fluze)'/ne);
             else
                 mon=sqrt(alpha+sum((fluze.*fluze)')/ne);
             end

         case('derfl2-1')
%...
%...     compute d2fl(u)/dz2 by 3_pt_centered scheme           
%...
             D2 = three_point_centered_D2(z);
             fuzz = D2*Flux_DynGrid(n,ne,t,u);
             fuzze = (fuzz(1:n+1,:)+fuzz(2:n+2,:))/2;
%...
%...     compute monitor function :
%...
%...                              1    ne     fuzz(i+1,j)+fuzz(i,j)
%...        m(i) = sqrt[ alpha + ---  sum abs(-------------------)]
%...                              ne  j=1           2  
%...
%...
             if ne==1
                 mon=sqrt(alpha+(abs(fuzze))'/ne);
             else
                 mon=sqrt(alpha+sum((abs(fuzze))')/ne);
             end

     end
